

public class ArrayQueue implements Queue
{

	public static final int CAPACITY = 1000;
	private Object S[];
	private int rear;
	private int front;

	public ArrayQueue()
	{
		S = new Object[CAPACITY];
		front = 0;
		rear = 0;
	}

	public int size()
	{ 
		return (CAPACITY + rear - front) % CAPACITY;
	}
	
	public boolean isEmpty()
	{
		return size() == 0;
	}

	public void enqueue(Object obj) throws FullQueueException
	{
		if (size() == CAPACITY-1)
			throw new FullQueueException();
		S[rear++] = obj;
		if ( rear == CAPACITY )
		   rear++;
	}

	public Object front() throws EmptyQueueException
	{
		if (isEmpty())
			throw new EmptyQueueException();
		return S[front];
	}

	public Object dequeue() throws EmptyQueueException
	{
		Object elem;
		if (isEmpty())
			throw new EmptyQueueException();
		elem = S[front];
		S[front++] = null; // dereference S[front] for garbage collection.
		if ( front == CAPACITY )
		   front++;
		return elem;
	}
	
}
